"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@cli-engine/command");
const util_1 = require("util");
const deps_1 = require("./deps");
const deprecatedCLI = util_1.deprecate(() => {
    return require('cli-ux').cli;
}, 'this.out and this.cli is deprecated. Please import the "cli-ux" module directly instead.');
class Command extends command_1.Command {
    get heroku() {
        if (this._heroku)
            return this._heroku;
        this._heroku = new deps_1.default.APIClient(this.config);
        return this._heroku;
    }
    get legacyHerokuClient() {
        if (this._legacyHerokuClient)
            return this._legacyHerokuClient;
        const HerokuClient = require('heroku-client');
        let options = {
            debug: this.config.debug,
            host: `${this.heroku.defaultOptions.protocol || 'https:'}//${this.heroku.defaultOptions.host ||
                'api.heroku.com'}`,
            token: this.heroku.auth,
            userAgent: this.heroku.defaultOptions.headers['user-agent'],
        };
        this._legacyHerokuClient = new HerokuClient(options);
        return this._legacyHerokuClient;
    }
    get cli() {
        return deprecatedCLI();
    }
    get out() {
        return deprecatedCLI();
    }
    get app() {
        return util_1.deprecate(() => {
            return this.flags.app;
        }, 'this.app is deprecated but you can implement it yourself as `get app() { return this.flags.app }`')();
    }
}
exports.Command = Command;
